javascript 中的try catch应用总结

时间:2021-1-8 作者:admin
<script language="javascript">
try
{
throw new Error(10,"asdasdasd")
}
catch (e)
{
alert(e.message);
alert(e.description)
alert(e.number)
alert(e.name)
throw new Error(10,"asdasdasd")
}
</script>  

在 JavaScript 可以使用 try…catch 来进行异常处理。例如:  

try {
 foo.bar();
} catch (e) {
 alert(e.name + ": " + e.message);
}

目前我们可能得到的系统异常主要包含以下 6 种:

  • EvalError: raised when an error occurs executing code in eval()  
  • RangeError: raised when a numeric variable or parameter is outside of its valid range  
  • ReferenceError: raised when de-referencing an invalid reference  
  • SyntaxError: raised when a syntax error occurs while parsing code in eval()  
  • TypeError: raised when a variable or parameter is not a valid type  
  • URIError: raised when encodeURI() or decodeURI() are passed invalid parameters  

上面的六种异常对象都继承自 Error 对象。他们都支持以下两种构造方法:

new Error();
new Error("异常信息");

手工抛出异常的方法如下:

try {
 throw new Error("Whoops!");
} catch (e) {
 alert(e.name + ": " + e.message);
}

如要判断异常信息的类型,可在 catch 中进行判断:

try {
 foo.bar();
} catch (e) {
 if (e instanceof EvalError) {
     alert(e.name + ":" + e.message);
 } 
 else if (e instanceof RangeError) {
     alert(e.name + ": " + e.message);
 } 
 // etc 
}

Error 具有下面一些主要属性:

  • description: 错误描述 (仅 IE 可用).  
  • fileName: 出错的文件名 (仅 Mozilla 可用).  
  • lineNumber: 出错的行数 (仅 Mozilla 可用).  
  • message: 错误信息 (在 IE 下同 description)  
  • name: 错误类型.  
  • number: 错误代码 (仅 IE 可用).  
  • stack: 像 Java 中的 Stack Trace 一样的错误堆栈信息 (仅 Mozilla 可用).  

因此为了更好的了解错误信息我们可以将 catch 部分改为如下形式:  

try {
 foo.bar();
} catch (e) {
 if (browserType != BROWSER_IE) {                               
     alert("name: " + e.name + 
      "message: " + e.message + 
      "lineNumber: " + e.lineNumber + 
      "fileName: " + e.fileName + 
      "stack: " + e.stack);           
 } 
 else {                       
     alert("name: " + e.name +        
      "errorNumber: " + (e.number & 0xFFFF ) + 
      "message: " + e.message");           
 } 
}

JavaScript 中的 throw 命令事实上可以抛出任何对象,并且我们可以在 catch 接受到此对象。例如:

try {
 throw new Date(); // 抛出当前时间对象 
} catch (e) {
 alert(e.toLocaleString()); // 使用本地格式显示当前时间 
}

原文:http://blog.csdn.net/ocean20/article/details/7301008

声明:本文内容由互联网用户自发贡献自行上传,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任。如果您发现有涉嫌版权的内容,欢迎进行举报,并提供相关证据,工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。